<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/28/2003 *
 * ===============                              Last change: 08/18/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_user.php                               *
 * -------------------------------------------------------------------- *
 * Short description : List all or partial members                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle oder nur bestimmte Mitglieder auflisten     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif ((!EXT_IS_ACTIVE("user")) || (GET_EXT_VERSION("user") == "")) {
	// Missing extension!
	ADD_FATAL(sprintf(EXTENSION_PROBLEM_NOT_INSTALLED, "user"));
	return;
}

// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

// Init title with "all accounts"
$listHeader = ADMIN_ALL_ACCOUNTS;
if (!empty($_GET['mode'])) {
	// Set title according to the "mode"
	$eval = sprintf("\$listHeader = ADMIN_LIST_%s_ACCOUNTS;", strtoupper(SQL_ESCAPE($_GET['mode'])));
	eval($eval);
} // END - if

// Remember it
define('__TITLE', $listHeader);

$MORE = ", userid"; $colspan = "4"; //                 27
if (EXT_IS_ACTIVE("nickname")) { $MORE = ", nickname"; }

if (empty($_GET['letter'])) { $_GET['letter'] = _ALL2;    }
if (empty($_GET['sortby'])) { $_GET['sortby'] = "userid"; }
if (empty($_GET['page']))   { $_GET['page']   = "1";      }

// Set base URL
$BASE = "[<A href=\"".URL."/modules.php?module=admin";

if (!empty($_GET['u_id'])) {
	// Secure the user ID
	$uid = bigintval($_GET['u_id']);

	// Does the account exists?        0      1        2         3       4     5      6       7         8          9          10           11           12         13     14         15           16          17            18           19           20           21        22        23             24              25         26
	$result = SQL_QUERY_ESC("SELECT gender, surname, family, street_nr, zip, city, country, email, birth_day, birth_month, birth_year, max_mails, receive_mails, refid, status, REMOTE_ADDR, last_online, last_module, ref_clicks, total_logins, used_points, emails_sent, joined, last_update, last_profile_sent, notified, ref_payout".$MORE."
FROM "._MYSQL_PREFIX."_user_data
WHERE userid=%s LIMIT 1",
	 array($uid), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Account found!
		$DATA  = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		$REFS  = GET_TOTAL_DATA($uid, "refsystem", "counter");
		$CATS  = GET_TOTAL_DATA($uid, "user_cats", "id", "userid", true);
		$LINKS = GET_TOTAL_DATA($uid, "user_links", "id", "userid", true);

		if ($LINKS > 0) $LINKS = $BASE."&amp;what=list_links&amp;u_id=".$uid."\">".$LINKS."</A>]";
		if ($DATA[13] > 0) $DATA[13] = str_replace(("u_id=".$uid), ("u_id=".$DATA[13]), $BASE."&amp;what=list_user\">".$DATA[13]."</A>]");
		if (empty($DATA[17])) $DATA[17] = "---";
		if ($REFS > 0) $REFS = $BASE."&amp;what=list_refs&amp;u_id=".$uid."\">".$REFS."</A>]";
		if ($CATS > 0) $CATS = $BASE."&amp;what=list_cats&amp;u_id=".$uid."\">".$CATS."</A>]";

		// Prepare data for template
		define('_BIRTHDAY', MAKE_DATETIME(mktime(0, 0, 0, $DATA[9], $DATA[8], $DATA[10]), "3"));
		define('_REFS' , $REFS);
		define('_CATS' , $CATS);
		define('_LINKS', $LINKS);
		define('_ADMIN_LINKS', MEMBER_ACTION_LINKS($uid, $DATA[14]));
		$DATA[0]      = TRANSLATE_GENDER($DATA[0]);
		$DATA[28]     = CREATE_EMAIL_LINK($DATA[7], "user_data");
		$DATA[14]     = TRANSLATE_STATUS($DATA[14]);
		$DATA[16]     = MAKE_DATETIME($DATA[16], "0");
		$DATA[20]     = TRANSLATE_COMMA($DATA[20]);
		if ($DATA[21] > 0) $DATA[21] = $BASE."&amp;what=email_details&amp;u_id=".$uid."\">".TRANSLATE_COMMA($DATA[21])."</A>]";
		$DATA[22]     = MAKE_DATETIME($DATA[22], "0");
		$DATA[23]     = MAKE_DATETIME($DATA[23], "0");
		$DATA[24]     = MAKE_DATETIME($DATA[24], "0");
		if ((empty($DATA[27])) || ($DATA[27] == $uid)) $DATA[27] = "---";
		$DATA['total']  = TRANSLATE_COMMA(GET_TOTAL_DATA($uid, "user_points", "points"));
		$DATA['locked'] = TRANSLATE_COMMA(GET_TOTAL_DATA($uid, "user_points", "locked_points"));

		if (EXT_IS_ACTIVE("nickname")) {
			if ((empty($DATA[27])) || ($DATA[27] == $uid)) $DATA[27] = "---";
		} else {
			$DATA[27] = EXT_NICKNAME_404;
		}

		// Template laden
		LOAD_TEMPLATE("admin_user_details", false, $uid);
	} else {
		// Account does not exists!
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_MEMBER_404_1.$uid.ADMIN_MEMBER_404_2);
	}
} else {
	$whereStatement = "";
	if (($_GET['letter'] != _ALL2) && ($_GET['letter'] != _OTHERS) && (!empty($_GET['letter']))) {
		// List only persons w
		$whereStatement = " WHERE family LIKE '".$_GET['letter']."%'";
	} // END - if
	if ($_GET['sortby'] == "family_name") $_GET['sortby'] = "family";

	// Parse the mode parameter
	if (isset($_GET['mode'])) {
		// Is a WHERE statement already there?
		if (!empty($whereStatement)) {
			// Then append the status column
			$whereStatement .= sprintf(" AND status='%s'", SQL_ESCAPE(strip_tags(strtoupper($_GET['mode']))));
		} else {
			// Start a new one
			$whereStatement = sprintf(" WHERE status='%s'", SQL_ESCAPE(strip_tags(strtoupper($_GET['mode']))));
		}
	} // END - if

	$SQL = "SELECT userid, gender, surname, family, email, REMOTE_ADDR, refid, status, emails_sent, mails_confirmed, emails_received".$MORE." FROM "._MYSQL_PREFIX."_user_data".$whereStatement." ORDER BY ".$_GET['sortby'];
	$result_master = SQL_QUERY($SQL, __FILE__, __LINE__);

	// Calculate page count (0.5 fixes a bug with page count)
	if ($_CONFIG['user_limit'] == 0) {
		$_CONFIG['user_limit'] = 100;
		LOAD_TEMPLATE("admin_settings_saved", false, EXTENSION_WARNING_USER_LIMIT);
	} // END - if

	// Activate the extension please!
	$PAGES = round(SQL_NUMROWS($result_master) / $_CONFIG['user_limit'] + 0.5);

	if (empty($_GET['page']))   $_GET['page']   = "1";
	if (empty($_GET['offset'])) $_GET['offset'] = $_CONFIG['user_limit'];

	// Add limitation to SQL string and run him again
	$SQL .= " LIMIT ".($_GET['offset'] * $_GET['page'] - $_GET['offset']).", ".$_GET['offset'];
	$result = SQL_QUERY($SQL, __FILE__, __LINE__);

	$result_user = SQL_QUERY("SELECT emails_sent FROM "._MYSQL_PREFIX."_user_data WHERE status='CONFIRMED'", __FILE__, __LINE__);
	$user_count = SQL_NUMROWS($result_user);
	SQL_FREERESULT($result_user);

	if (SQL_NUMROWS($result_master) > 0) {
		// Free memory
		SQL_FREERESULT($result_master);

		// We have some (new?) registrations!
		define('__COLSPAN1'  , $colspan);
		define('__COLSPAN2'  , ($colspan + 2));
		define('__USER_CNT'  , $user_count);

		if ((function_exists('alpha')) && (function_exists('SortLinks'))) {
			define('__ALPHA_SORT', alpha($_GET['sortby'], $colspan, true));
			define('__SORT_LINKS', SortLinks($_GET['letter'], $_GET['sortby'], $colspan, true));
		} else {
			define('__ALPHA_SORT', "");
			define('__SORT_LINKS', "");
		}

		if ($PAGES > 1) {
			define('__PAGE_NAV', ADD_PAGENAV($PAGES, $_CONFIG['user_limit'], true, $colspan, true));
		} else {
			// No page navigation is required
			define('__PAGE_NAV', "");
		}

		// Column with nickname when nickname extension is present
		if (EXT_IS_ACTIVE("nickname"))
		{
			// Nickname extension found
			define('__NICKNAME_TH', "  <TD class=\"admin_title bottom2\" align=\"center\">".NICKNAME."</TD>");
		}
		 else
		{
			// Not found
			define('__NICKNAME_TH', "");
		}

		$SW = 2; $OUT = "";
		while (list($uid, $gender, $sname, $fname, $email, $IP, $ref, $status, $emails_sent, $mails_confirmed, $emails_received, $nick) = SQL_FETCHROW($result)) {
			if ($ref > 0) $ref = ADMIN_USER_PROFILE_LINK($ref);
			$LINKS = GET_TOTAL_DATA($uid, "user_links", "id", "userid", true);
			$SENT = $emails_sent;
			if ($emails_sent > 0) $SENT = $BASE."&amp;what=email_details&amp;u_id=".$uid."\">".TRANSLATE_COMMA($emails_sent)."</A>]";
			if ($LINKS > 0) $LINKS = $BASE."&amp;what=list_links&amp;u_id=".$uid."\">".TRANSLATE_COMMA($LINKS)."</A>]";

			// Add nickname
			if (empty($nick) || $nick == $uid) $nick = "---";

			// Calculate total points
			$pointsTotal = GET_TOTAL_DATA($uid, "user_points", "points")  - GET_TOTAL_DATA($uid, "user_data", "used_points");

			// Clickrate
			$clickRate = 0;
			if ($emails_received > 0) {
				$clickRate = $mails_confirmed / $emails_received * 100;
			} // END - if

			// Transfer data to array
			$content = array(
				'sw'     => $SW,
				'uid'    => ADMIN_USER_PROFILE_LINK($uid),
				'gender' => TRANSLATE_GENDER($gender),
				'sname'  => $sname,
				'fname'  => $fname,
				'email'  => "[<A href=\"".CREATE_EMAIL_LINK($email, "user_data")."\">".$email."</A>]",
				'addr'   => $IP,
				'ref'    => $ref,
				'status' => TRANSLATE_STATUS($status),
				'links'  => $LINKS,
				'nick'   => $nick,
				'alinks' => MEMBER_ACTION_LINKS($uid, $status),
				'points' => TRANSLATE_COMMA($pointsTotal),
				'sent'   => $SENT,
				'rate'   => TRANSLATE_COMMA($clickRate),
				'locked' => TRANSLATE_COMMA(GET_TOTAL_DATA($uid, "user_points", "locked_points"))
			);

			// Load row template and switch colors
			$OUT .= LOAD_TEMPLATE("admin_list_user_row", true, $content);
			$SW = 3 - $SW;
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		define('__USER_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_list_user");

		// Free some memory
		SQL_FREERESULT($result_master);
	} else {
		// No one as registered so far! :-(
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_NO_NONE_REGISTERED);
	}
}

//
?>
